

#include <iostream.h>

int T, K, L;

char keynames[200], letternames[200];
int freq[200];

int key[200][200];
int nl[200];

int zysk( int i, int af )
{
    if( i==0 ) return 0;
    int k;
    int f1=0, f2=0;
    for( k=0; k<nl[i]; k++ ) {
	f1 += freq[ key[i][k] ] * (k+1);
	f2 += freq[ key[i][k] ] * k;
    }
    f2 += af*k;
    if( f2<f1 ) return 0;
    return f2 - f1;
}

void likemove( int i )
{
    if( i==0 ) return;
    if( zysk( i-1, freq[ key[i][0] ]) + zysk( i, 0 ) > 0 ) {
	key[i-1][ ++nl[i-1]] = key[i][0];
	for( int j=1; j<nl[i]; j++ )
	    key[i][j-1]=key[i][j];
	nl[i]--;
	likemove( i-1 );
    }
}

int main()
{
    cin >>T;
    while( T-- ) {
	cin >> K >> L;
	cin >> keynames >> letternames;
	int i;
	for( i=0; i<L; i++ ) cin >> freq[i];
	
	for( i=0; i<K; i++ ) {
	    nl[i] = 1;
	    key[i][0] = i;
	}
	for( ; i<L; i++ ) {
	    nl[K-1] ++;
	    key[ K-1 ][ nl[K-1] ] = i;
	    likemove( K-1 );
	}
    }
    for( int i=0; i<K; i++ ) {
	cout << keynames[i] << ": ";
	for( int j=0; j<nl[i]; j++ )
	    cout << letternames[ key[i][j] ];
	cout << "\n";
    }

    return 0;
}
